local GearingGuide = LibStub("AceAddon-3.0"):GetAddon("Gearing Guide")

function GearingGuide:PriorityTable ()
	local tablePrio = {}
	tablePrio = {
	{class = "Death Knight", spec = "Blood", Stamina = 5, Strength = 5, Agility = 0, Intellect = 0, mastery = 1.4, critical = 1.14, haste = 4.27, multistrike = 4.63, versatility = 3.56, spirit = 0, armor = 5, prio = 0},
	{class = "Death Knight", spec = "Frost", Stamina = 0, Strength = 5, Agility = 0, Intellect = 0, mastery = 3.46, critical = 2.78, haste = 2.66, multistrike = 3.11, versatility = 2.99, spirit = 0, armor = 0, prio = 0},	
	{class = "Death Knight", spec = "Unholy", Stamina = 0, Strength = 5, Agility = 0, Intellect = 0, mastery = 3.41, critical = 2.92, haste = 2.43, multistrike = 3.47, versatility = 2.75, spirit = 0, armor = 0, prio = 0},

	{class = "Druid", spec = "Balance", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 3.07, critical = 3.08, haste = 3.05, multistrike = 3.04, versatility = 2.74, spirit = 0, armor = 0,  prio = 0},
	{class = "Druid", spec = "Feral", Stamina = 0, Strength = 0, Agility = 5, Intellect = 0, mastery = 2.81, critical = 3.22, haste = 2.97, multistrike = 3.12, versatility = 2.9, spirit = 0, armor = 0,  prio = 0},
	{class = "Druid", spec = "Guardian", Stamina = 5, Strength = 0, Agility = 5, Intellect = 0, mastery = 7.46, critical = 0.14, haste = 1.17, multistrike = 0.39, versatility = 5.82, spirit = 0, armor = 5,  prio = 0},
	{class = "Druid", spec = "Restoration", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 3.14, critical = 2.84, haste = 3.21, multistrike = 3.06, versatility = 2.76, spirit = 3, armor = 0,  prio = 0},
	
	{class = "Hunter", spec = "Beast Mastery", Stamina = 0, Strength = 0, Agility = 5, Intellect = 0, mastery = 3.05, critical = 3.02, haste = 2.84, multistrike = 3.14, versatility = 2.96, spirit = 0, armor = 0, prio = 0},
	{class = "Hunter", spec = "Marksman", Stamina = 0, Strength = 0, Agility = 5, Intellect = 0, mastery = 2.75, critical = 3.11, haste = 2.76, multistrike = 3.33, versatility = 3.05, spirit = 0, armor = 0, prio = 0},
	{class = "Hunter", spec = "Survival", Stamina = 0, Strength = 0, Agility = 5, Intellect = 0, mastery = 2.62, critical = 3.14, haste = 2.58, multistrike = 3.55, versatility = 3.13, spirit = 0, armor = 0, prio = 0},
	
	{class = "Mage", spec = "Arcane", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 3.33, critical = 2.93, haste = 2.93, multistrike = 3.04, versatility = 2.75, spirit = 0, armor = 0, prio = 0},
	{class = "Mage", spec = "Fire", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 3.02, critical = 3.65, haste = 2.85, multistrike = 2.89, versatility = 2.58, spirit = 0, armor = 0, prio = 0},
	{class = "Mage", spec = "Frost", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 2.66, critical = 3.1, haste = 2.72, multistrike = 3.52, versatility = 3.02, spirit = 0, armor = 0, prio = 0},	
	
	{class = "Monk", spec = "Brewmaster", Stamina = 5, Strength = 0, Agility = 5, Intellect = 0, mastery = 5.67, critical = 1.65, haste = 2.66, multistrike = 1.3, versatility = 3.73, spirit = 0, armor = 5, prio = 0},
	{class = "Monk", spec = "Mistweaver", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 2.63, critical = 3.24, haste = 2.78, multistrike = 3.39, versatility = 2.94, spirit = 3, armor = 0, prio = 0},
	{class = "Monk", spec = "Windwalker DW", Stamina = 0, Strength = 0, Agility = 5, Intellect = 0, mastery = 2.21, critical = 3.19, haste = 3.02, multistrike = 3.36, versatility = 3.21, spirit = 0, armor = 0, prio = 0},
	
	{class = "Paladin", spec = "Holy", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 2.97, critical = 3.42, haste = 2.66, multistrike = 3.12, versatility = 2.81, spirit = 3, armor = 0, prio = 0},
	{class = "Paladin", spec = "Protection", Stamina = 5, Strength = 5, Agility = 0, Intellect = 0, mastery = 4.08, critical = 1.87, haste = 3.19, multistrike = 0.85, versatility = 5.01, spirit = 0, armor = 5, prio = 0},
	{class = "Paladin", spec = "Retribution", Stamina = 0, Strength = 5, Agility = 0, Intellect = 0, mastery = 3.3, critical = 2.94, haste = 2.69, multistrike = 3.18, versatility = 2.89, spirit = 0, armor = 0, prio = 0},
	
	{class = "Priest", spec = "Discipline", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 3.21, critical = 3.29, haste = 2.69, multistrike = 2.99, versatility = 2.83, spirit = 3, armor = 0, prio = 0},
	{class = "Priest", spec = "Holy", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 3.15, critical = 3, haste = 2.69, multistrike = 3.3, versatility = 2.84, spirit = 3, armor = 0, prio = 0},
	{class = "Priest", spec = "Shadow", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 3.22, critical = 2.93, haste = 3.12, multistrike = 2.95, versatility = 2.77, spirit = 0, armor = 0, prio = 0},	
	
	{class = "Rogue", spec = "Assassination", Stamina = 0, Strength = 0, Agility = 5, Intellect = 0, mastery = 3.05, critical = 3.07, haste = 2.85, multistrike = 3.16, versatility = 2.89, spirit = 0, armor = 0, prio = 0},	
	{class = "Rogue", spec = "Combat", Stamina = 0, Strength = 0, Agility = 5, Intellect = 0, mastery = 2.97, critical = 2.88, haste = 3.18, multistrike = 3.1, versatility = 2.87, spirit = 0, armor = 0, prio = 0},
	{class = "Rogue", spec = "Subtlety", Stamina = 0, Strength = 0, Agility = 5, Intellect = 0, mastery = 3.21, critical = 2.89, haste = 2.75, multistrike = 3.31, versatility = 2.83, spirit = 0, armor = 0, prio = 0},
	
	{class = "Shaman", spec = "Elemental", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 2.89, critical = 3.08, haste = 2.96, multistrike = 3.28, versatility = 2.8, spirit = 0, armor = 0, prio = 0},
	{class = "Shaman", spec = "Enhancement", Stamina = 0, Strength = 0, Agility = 5, Intellect = 0, mastery = 3.04, critical = 2.93, haste = 2.98, multistrike = 3.12, versatility = 2.91, spirit = 0, armor = 0, prio = 0},
	{class = "Shaman", spec = "Restoration", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 3.15, critical = 3.3, haste = 2.69, multistrike = 3, versatility = 2.84, spirit = 3, armor = 0, prio = 0},
	
	{class = "Warlock", spec = "Affliction", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 3.24, critical = 2.95, haste = 3.08, multistrike = 2.97, versatility = 2.78, spirit = 0, armor = 0, prio = 0},
	{class = "Warlock", spec = "Demonology", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 2.96, critical = 3.02, haste = 3.25, multistrike = 3, versatility = 2.78, spirit = 0, armor = 0, prio = 0},
	{class = "Warlock", spec = "Destruction", Stamina = 0, Strength = 0, Agility = 0, Intellect = 5, mastery = 2.95, critical = 3.12, haste = 2.96, multistrike = 3.07, versatility = 2.88, spirit = 0, armor = 0, prio = 0},

	{class = "Warrior", spec = "Arms", Stamina = 0, Strength = 5, Agility = 0, Intellect = 0, mastery = 2.94, critical = 3.45, haste = 2.8, multistrike = 2.99, versatility = 2.84, spirit = 0, armor = 0, prio = 0},
	{class = "Warrior", spec = "Fury", Stamina = 0, Strength = 5, Agility = 0, Intellect = 0, mastery = 3.02, critical = 3.26, haste = 2.8, multistrike = 3.21, versatility = 2.73, spirit = 0, armor = 0, prio = 0},
	{class = "Warrior", spec = "Protection", Stamina = 5, Strength = 5, Agility = 0, Intellect = 0, mastery = 3.6, critical = 3.74, haste = 0.7, multistrike = 1.74, versatility = 5.2, spirit = 0, armor = 5, prio = 0},
	{class = "Warrior", spec = "Gladiator", Stamina = 0, Strength = 5, Agility = 0, Intellect = 0, mastery = 2.73, critical = 3.26, haste = 3.21, multistrike = 3, versatility = 2.79, spirit = 0, armor = 2.5, prio = 0}
	}

	return tablePrio
end